Subject: [bug#56504] [PATCH] Mingw support for zlib

From: Liliana Marie Prikler <[email-masked]>
Date: Wed, 13 Jul 2022 07:49:17 +0200

Am Dienstag, dem 12.07.2022 um 18:45 +0200 schrieb Vivien Kraus:
> Le mardi 12 juillet 2022 à 08:07 +0200, Liliana Marie Prikler a
> écrit :
> > Am Dienstag, dem 12.07.2022 um 01:53 +0200 schrieb Vivien Kraus:
> > 
> > > +               ,@(if (and (%current-target-system)
> > > +                          (string-suffix? "-w64-mingw32"
> > > (%current-
> > > target-system)))
> > I'm pretty sure there's an abbreviation for this like target-mingw?
> Precisely! Fixed it, thank you.
> 
> > > +                     `((substitute* "win32/Makefile.gcc"
> > > +                         (("PREFIX =")
> > > +                          (string-append "PREFIX = " ,(%current-
> > > target-system) "-"))
> > > +                         (("prefix \\?= /usr/local")
> > > +                          (string-append "prefix ?= " out))
> > > +                         (("# BINARY_PATH, INCLUDE_PATH and
> > > LIBRARY_PATH must be set.")
> > > +                          "\
> > > +BINARY_PATH = $(prefix)/bin
> > > +INCLUDE_PATH = $(prefix)/include
> > > +LIBRARY_PATH = $(prefix)/lib"))
> > > +                       (rename-file "win32/Makefile.gcc"
> > > "Makefile"))
> > I think these can be conditionally added to #:make-flags
> I did it for all but prefix, because I have to have the output path.
> Is there a way to get it from within the make-flags?
With the gexp-style you'd write #$output, otherwise ,(assoc-ref %build-
outputs "out").

> > > +                     `((invoke "./configure"
> > > +                               (string-append "--prefix="
> > > out)))))))
> > 
> > > +         ,@(if (and (%current-target-system)
> > > +                    (string-suffix? "-mingw32" (%current-target-
> > > system)))
> > > +               `(add-after 'install 'install-mingw-shared
> > > +                  (lambda* (#:key make-flags #:allow-other-keys)
> > > +                    (apply invoke "make"
> > > +                           (append make-flags
> > > +                                   '("install"
> > > "SHARED_MODE=1")))))
> > SHARED_MODE might likewise be conditionally added to #:make-flags.
> I get both the DLL loader and the DLL in the default output, and the
> static lib in the static output, so it works.
Oh, so you mean the static output should be built without SHARED_MODE?

Cheers